#!/usr/bin/python
#
# smb mounter copyright (c) 2002-2004 Ian Hubbertz
# patches by Tillmann Steinbrecher
#
# May be distributed according to the rules of the
# GNU General Public License, Version 2
#
# THIS SCRIPT SPAWNS OS COMMANDS BASED ON DATA IT RETRIEVED
# FROM THE NETWORK. RUN ONLY IN TRUSTED LANs, and make sure
# you know what the risks are, especially when running it as root!

import os;
import tempfile;

# work dir
WORKDIR="/home/tst/listfiles/"

# subdir of work dir where the list files will be saved
SUBDIR="listen/"

# server to get LAN host list from (WINS server)
BROWSESERVER="192.168.0.75"

# command for unmounting
# You can use "smbumount" or "umount". The advantage
# of using smbumount is that you can run this script as
# normal user.  However, smbmount will sometimes fail
# in case of Input/output error, and you will end up
# with hung mounts. umount is more robust here, but
# requires root.
UMOUNTCMD="smbumount"


def smb_get_serverliste(server):
    try:
        f = os.popen("smbclient /// \"\" -L%s -U%%"%(server))
    except IOError:
        print ("IOError while getting host list from "+server)
        exit(0)
        
    ausgabe = f.readlines()

    found = 0;
    serverliste=[]
        
    for s in ausgabe:
        if (found):
            temp = s.split()
            if (temp.count("Workgroup")): found=0
            elif (temp.count("---------")): pass
            elif (temp): serverliste.append(temp[0])
        else:
            if s.split() == ["Server", "Comment"]:
                found=1
    return serverliste;



def smb_get_shareliste(host):
    try:
        f = os.popen("smbclient /// \"\" -L"+host)
    except IOError:
        print ("IOError while fetching Share list from "+host)
        return 0;

    ausgabe = f.readlines()

    found = 0;
    shareliste=[]
        
    for s in ausgabe:
        if (found):
            temp = s.split()
            if (temp.count("Server")): found=0
            elif (temp.count("---------")): pass
            elif (temp):
                if ((temp[0].find("$")==-1) and (temp[1]=="Disk")): shareliste.append(temp[0])
        else:
            if s.split() == ["Sharename", "Type", "Comment"]:
                found=1
    return shareliste;


def smb_mount_share(host, share):
    os.chdir(WORKDIR)
    td=tempfile.mktemp(".d")
    print td
    os.mkdir(td)
    print "Executing: smbmount //"+host+"/"+share+" "+td
    mount=os.popen("smbmount //"+host+"/"+share+" "+td+" -opassword=\"\"")
    print mount.readlines()
    mount.close()
    
    try:
        os.chdir(td)
	ls=os.popen("ls -lR")
        os.chdir(WORKDIR)
	
    except Exception:
	os.chdir(WORKDIR)
	print "Error reading mount!"

    of=open(SUBDIR+host+"_"+share,'w')
    for s in ls.readlines():
        of.write(s)
    ls.close()
    
    try:
	print "Unmounting - Executing: "+UMOUNTCMD+" "+td
        mount=os.popen(UMOUNTCMD+" "+td)
        print mount.readlines()
        mount.close()
        os.rmdir(td)
    except Exception:
	print "Error unmounting "+td
	
    return 0


for host in smb_get_serverliste(BROWSESERVER):
    print "Host: "+host
    print "WD: "+os.getcwd()
    for share in smb_get_shareliste(host):
        print "---->Share: "+share
        smb_mount_share(host,share)
    
